package workload

import (
	"fmt"
	"os"

	"github.com/sirupsen/logrus"
	"gopkg.in/yaml.v2"
)

type Workload struct {
	Kind     string
	Replicas int
}

func ReadFromFile(bundlePath string) (*Workload, error) {
	var workload Workload
	logrus.Infof("readig the workload file: %s", bundlePath)
	bundleFile, err := os.ReadFile(bundlePath)
	if err != nil {
		return nil, err
	}
	if err := yaml.Unmarshal(bundleFile, &workload); err != nil {
		return nil, err
	}
	return &workload, nil
}

func (wd *Workload) ValidateKind() error {
	if wd.Kind == "Deployment" || wd.Kind == "StatefulSet" || wd.Kind == "DaemonSet" {
		return nil
	}
	err := fmt.Errorf("kind is not valid, expect Deployment|StatefulSet|DaemonSet, got %s", wd.Kind)
	return err
}
